;-----------------------------------------------------------------------
;			16C84.H
;-----------------------------------------------------------------------
;
;	Header file to provide standard equates for the PIC 16C84
;

;  File registers in page 0

indirect equ  0	; Indirect memory reference
TMR0	equ  1	; Real Time Counter Timer
PCL	equ  2  ; Low 8 bytes of the Program Counter
pcl	equ  2
status	equ  3	; Status register
ptr	equ  4	; Indirect address (register holds it)
PortA	equ  5	; Port A
PortB	equ  6	; Port B
EEdata	equ  8	; EEPROM data
EEadr	equ  9  ; EEPROM address
PCLATH	equ 0Ah	; Hi bits of the Program Counter
INTCON	equ 0Bh	; Interrupt control register

; Additional File registers in page 1

optreg	equ 01h	; option register
trisA	equ 05h	; Tris state control on port A
trisB	equ 06h	; Tristate control on Port B
EEcon1	equ 08h	; EEPROM control register 1
EEcon2	equ 09h	; EEPROM control register 2

; Bits in the Status register

C	equ  0
c	equ  0
Z	equ  2
z	equ  2

; Bits in EEcon1

RD	equ  0
WR	equ  1
WRen	equ  2

; A few Macros to improve readability

jz	macro	x
	btfsc	3,2
	goto	x
	endm

