;-----------------------------------------------------------------------------;
; S Y S T E R  -  NAGRAVISION - SMARTKEY PROTOCOL SPY / COMPRESSOR V1.0 (1993)
;
;-----------------------------------------------------------------------------
;
;to be received:	serial triplets    of 9-bit data (9600 baud) RXD PIN
;                       from SMARTKEY
;to be xmitted :        parallel data  9 bits wide via port1 & port3.4
;                       strobed with port3.5
;
;                       serial quadruplets of 8-bit data (9600 baud) TXD PIN
;			hi bits gathered into 4th byte: 1>bit5, 2>bit6, 3>bit7
;                       repeated triplets sent once, repeat counter byte4.0..4
;                                                    xxx00000B means 32 !
;                       to PC
;
;hardware needed:       any 11.059 MHz 8031 experimental system;
;                       SYSTER-DECODER / -KEY;
;                       KEY-ADAPTER or opened decoder and wires... (easy)
;                       PREMIERE / TELECLUB - reception
;                       PC
;
;-----------------------------------------------------------------------------
;
PARPRT	EQU	P1
LEDPIN	EQU	P3.3
BIT8PIN	EQU	P3.4
STROBE	EQU	P3.5
;
STACK	EQU	060H
OLD1	EQU	008H			;	old byte 1
OLD2	EQU	OLD1+1			;	old byte 2
OLD3	EQU	OLD2+1			;	old byte 3
OLD4	EQU	OLD3+1			;	old byte 4 (only 3 bits)
;
REPCNT	EQU	OLD4+1			;	repeat counter
RCVCNT	EQU	REPCNT+1		;	receive count
;
NEW1	EQU	010H
NEW2	EQU	NEW1+1
NEW3	EQU	NEW2+1
NEW4	EQU	NEW3+1
;
;-----------------------------------------------------------------------------
;
	CSEG	AT	00000H
;
	LJMP	START
;
;=============================================================================
;
	CSEG	AT	00023H
;
	JNB	RI,SEREX	;	nothing received - good bye
;
	SETB	STROBE		;	unstrobe data (inactive hi)
	PUSH	ACC
;
	MOV	A,SBUF		;	get byte
	MOV	C,RB8		;	get hi bit
;
	MOV	PARPRT,A	;	xmit received byte (8 bit par)
	MOV	@R0,A		;	save byte
	MOV	BIT8PIN,C	;	xmit bit 8 status
;
	MOV	A,NEW4		;	get byte 4 (hi bits storage)
	RRC	A		;	rotate bit 8 status into byte 4
	ANL	A,#11100000B
	MOV	NEW4,A		;	save hi bits status
;
	CLR	STROBE		;	strobe data (active lo)
;
	INC	R0		;	address for next byte to rcv
	INC	RCVCNT		;	received bytes counter + 1
;
	POP	ACC
	CLR	RI
;
SEREX:
	RETI
;
;=============================================================================
;
	CSEG	AT	00080H
START:
	MOV	SP,#STACK-1		;	stack pointer
;
	CALL	OLDINI			;	ini previously received bytes
	MOV	NEW4,#0			;	reset hi bits status
	MOV	REPCNT,#1		;	reset repeats
	CALL	RSINI			;	ini serial interface
;
;============================================================================
;
LOOP:
	MOV	R0,#NEW1		;	receive pointer
;	MOV	R1,#OLD1		;	send pointer
;
	CALL	WT5MS			;	wait 5 ms
	MOV	RCVCNT,#0		;	nothing received so far
	CALL	INI9IN			;	9 bit serial reception mode
;
;-----------------------------------------------------------------------------
;
	MOV	A,#3			;	3 bytes to be rcvd
	CLR	C
WTRIPL:					;	wait for triplet reception
	JC	OVRCVD			;	too many bytes received
	CJNE	A,RCVCNT,WTRIPL
;
;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
;
	CLR	REN			;	no reception now
;
	MOV	A,OLD1
	CJNE	A,NEW1,NWTRPL
;
	MOV	A,OLD2
	CJNE	A,NEW2,NWTRPL
;
	MOV	A,OLD3
	CJNE	A,NEW3,NWTRPL
;
	MOV	A,OLD4
	CJNE	A,NEW4,NWTRPL
;
;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
;
OLTRPL:
	INC	REPCNT			;	same triplet received
	MOV	A,REPCNT
	ANL	A,#00011111B		;	only 5 bits matter
	JZ	PUT32
;
	JMP	LOOP			;	get next triplet
;
PUT32:
	ANL	OLD4,#11100000B		;	counter = 0 means counter = 32
	JMP	OUT4
;
;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
;
NWTRPL:
	ANL	OLD4,#11100000B
	ANL	REPCNT,#00011111B
	MOV	A,OLD4
	ORL	A,REPCNT		;	counter
	MOV	OLD4,A
;
OUT4:
	CALL	INI8OUT
;
	jnb	ti,$			;	wait until last byte xmitted
	clr	ti			;	reset xmit int
	MOV	SBUF,OLD1		;	put byte on its way
;
	jnb	ti,$			;	wait until last byte xmitted
	clr	ti			;	reset xmit int
	MOV	SBUF,OLD2		;	put byte on its way
;
	jnb	ti,$			;	wait until last byte xmitted
	clr	ti			;	reset xmit int
	MOV	SBUF,OLD3		;	put byte on its way
;
	jnb	ti,$			;	wait until last byte xmitted
	clr	ti			;	reset xmit int
	MOV	SBUF,OLD4		;	put byte on its way
;
	MOV	OLD1,NEW1
	MOV	OLD2,NEW2
	MOV	OLD3,NEW3
	MOV	OLD4,NEW4
;
	MOV	REPCNT,#1
;
	JMP	LOOP
;
;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
;
	JMP	LOOP
;
;-----------------------------------------------------------------------------
;
OVRCVD:					;	too many bytes received
	CPL	LEDPIN
	JMP	START
;
;=============================================================================
;-----------------------------------------------------------------------------
;		init serial port to 9600 baud (pcon.7 (smod) = 0)
;		timer1 reload val 0fdH at 11.059 MHz XTAL freq
;-----------------------------------------------------------------------------
;
rsini:	mov	pcon,#00000000B	;	#00H for 9k6, #80H for 19k2
	mov	tmod,#00100000B	;	#20H 8 bit auto reload timer mode
	mov	th1, #11111101B	;	#0fdH for 9600 / 19200 reload val
	mov	scon,#11000000B	;	#0f0H 9 bit uart mode 1 receive disabld
	setb	tr1		;	tcon.6 switch timer 1 on
	setb	ps		;	serial int high priority
	setb	es		;	enable serial port interrupt
	setb	ea		;	enable all selected interrupts
;
	ret
;
;-----------------------------------------------------------------------------
;
ini8out:
	clr	es		;	disable serial port interrupt
	mov	scon,#01000000B	;	#0f0H 8 bit uart mode 1 rcve disabled
	clr	ri
	setb	ti
	ret
;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
ini9in:
	mov	scon,#11010000B	;	#0f0H 9 bit uart mode 1 receive enabled
	clr	ti
	setb	es		;	enable serial port interrupt
	ret
;
;-----------------------------------------------------------------------------
;
					;	wait for  5ms dta line silence
					;	this should lead between tripel
WT5MS:
	JNB	RXD,$			;	1st await HI
;
W5S0:
	MOV	R5,#0
	MOV	R4,#5
W5S1:
	JNB	RXD,W5S0		; 2	no silence - so new wait cycle
	DJNZ	R5,W5S1			; 2
	DJNZ	R4,W5S1			; 2
;
	RET
;
;-----------------------------------------------------------------------------
;
OLDINI:
	MOV	OLD1,#0FFH		;	default values
	MOV	OLD2,#0FFH
	MOV	OLD3,#001H
;
	MOV	OLD4,#10100000B		;	8th bits status for byte 1,2,3
;
	RET
;
;-----------------------------------------------------------------------------
;		serial output accu via rs232
;-----------------------------------------------------------------------------
;
rsout:	jnb	ti,$		;	wait until last byte xmitted
	clr	ti		;	reset xmit int
	mov	sbuf,a		;	put byte on its way
;
	ret
;
;
;-----------------------------------------------------------------------------
;
NIBTOHEX:			;	nibble in A --> hex character
;				;	this is the BEST routine available
;				;	for Z80/INTEL processors !!!
;				;	(courtesy of Lance A. Leventhal)

	ADD	A,#090H		;	develop extra 6 & carry
	DA	A
	ADDC	A,#040H		;	add in carry, ascii offset
	DA	A		;	hex char (0..9, A..F) now in A
;
	RET
;
;-----------------------------------------------------------------------------
;
	END
;
;									-bm-
;-----------------------------------------------------------------------------
