;---------------------------------------------------------------------------
;Const
;---------------------------------------------------------------------------

c           equ     $0
z           equ     $2
rp0         equ     $5
irp         equ     $7
w           equ     $0
indf        equ     $0
tmr0        equ     $1
pcl         equ     $2
status      equ     $3
fsr         equ     $4
portb       equ     $6
eedata      equ     $8
eeadr       equ     $9
pclath      equ     $a
eecon1      equ     $8
xt          equ     $1

;--------------------------------------------------------------------------
;Macros
;--------------------------------------------------------------------------

movlwf      macro   arg1,arg2       ;Move literal to w and then to FReg.
            movlw   arg1
            movwf   arg2
            endm
            
movfwf      macro   arg1,arg2       ;Move FReg. to w and then to FReg.
            movf    arg1,w
            movwf   arg2
            endm

btfgc       macro   arg1,arg2,arg3  ;Bit-Test and goto if clear
            btfss   arg1,arg2
            goto    arg3
            endm
            
btfgs       macro   arg1,arg2,arg3  ;Bit-Test and goto if set
            btfsc   arg1,arg2
            goto    arg3
            endm

decfg       macro   arg1,arg2       ;Decrement Filereg. and Goto until zero
            decfsz  arg1
            goto    arg2
            endm
            
incfg       macro   arg1,arg2       ;Increment Filereg. and Goto until zero
            incfsz  arg1
            goto    arg2
            endm

iffeqg      macro   arg1,arg2,arg3  ;if Filereg.(arg2)=Arg1 then goto arg3
            movlw   arg1
            xorwf   arg2,w
            btfsc   status,z
            goto    arg3
            endm
            
ifweqg      macro   arg1,arg2       ;if w=Arg1 then goto arg2
            xorwf   arg1,w
            btfsc   status,z
            goto    arg2
            endm
            
            end
